/*******************************************************************************
 *
 * Copyright (c) 2016-2026 HYCON Technology, Inc.
 * All rights reserved.
 * HYCON Technology <www.hycontek.com>
 *
 * HYCON reserves the right to amend this code without notice at any time.
 * HYCON assumes no responsibility for any errors appeared in the code,
 * and HYCON disclaims any express or implied warranty, relating to sale
 * and/or use of this code including liability or warranties relating
 * to fitness for a particular purpose, or infringement of any patent,
 * copyright or other intellectual property right.
 *
 * -----------------------------------------------------------------------------
 * File Name    : user_sample.c
 * IDE tooling  : AndeSight C/C++ IDE, version: 2.0.1 Build ID : 201303201736
 * Device Ver.  : V0.9 crt0.o for HY16F19xx & HY16F18xx MCU.
 * Library Ver. : 1.1
 * MCU Device   : HY16F198B-L100 @3.0V
 * Description  : This file implements the customer's function.
 * Created Date : 2016/05/28
 * Created by   :
 *
 ******************************************************************************/

/*----------------------------------------------------------------------------*/
/* Header file include                                                        */
/*----------------------------------------------------------------------------*/
//#include "stdint.h"
#include "HY16F198.h"
#include "System.h"
#include "DrvADC.h"
#include "DrvClock.h"
#include "DrvPMU.h"
#include "DrvGPIO.h"
#include "DrvLCD.h"
#include "DrvREG32.h"
#include "DrvRTC.h"
#include "DrvTimer.h"
#include "DrvUART.h"
#include "DrvFlash.h"
#include "ModuleID.h"
#include "SpecialMacro.h"
#include "Sysinfra.h"
#include "user_DEF.h"
#include "user_LCD.h"

//#include "DrvCMP.h"

/*----------------------------------------------------------------------------*/
/* Structure definition                                                       */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* Global variable definition                                                 */
/*----------------------------------------------------------------------------*/



unsigned int  Sleep_Time_Cnt;
unsigned char DisplayBuffer[18];

unsigned char Key_DB_Cnt;
unsigned int  NoKey_Reset_Cnt;
unsigned int  NoKeyBuf[4];
unsigned char NoBuf_Idx;

unsigned char Beep_Tone_Cnt;
unsigned char Key_Code_Buf;
unsigned char Key_Code_No;

unsigned int  ADC_busy;

unsigned char i;

int ADCData;
#define  Disable 0
#define  Enable  1
unsigned int key_Mode;
signed int sum,ADtemp10,ADtemp101,ADtemp100;//,ADCData;//AD
signed int ADtemp20n,ADtemp20p,ADtemp200,ADtemp110n,ADtemp110p,ADtemp1100,average; //pܥ
int nu,ch,ok;															//P_
int value_buf[16];

/*----------------------------------------------------------------------------*/
/* Constant value definition                                                  */
/*----------------------------------------------------------------------------*/
unsigned char seg[]=
{
	seg_a+seg_b+seg_c+seg_d+seg_e+seg_f, 		// char "0"
	seg_b+seg_c,                         		// char "1"
	seg_a+seg_b+seg_d+seg_e+seg_g,       		// char "2"
	seg_a+seg_b+seg_c+seg_d+seg_g,       		// char "3"
	seg_b+seg_c+seg_f+seg_g,             		// char "4"
	seg_a+seg_c+seg_d+seg_f+seg_g,       		// char "5"
	seg_a+seg_c+seg_d+seg_e+seg_f+seg_g, 		// char "6"
	seg_a+seg_b+seg_c,                   		// char "7"
	seg_a+seg_b+seg_c+seg_d+seg_e+seg_f+seg_g,  // char "8"
	seg_a+seg_b+seg_c+seg_d+seg_f+seg_g, 		// char "9"
	seg_a+seg_b+seg_c+seg_e+seg_f+seg_g, 		// char "A"
	seg_c+seg_d+seg_e+seg_f+seg_g,       		// char "b"
	seg_a+seg_d+seg_e+seg_f,             		// char "C"
	seg_b+seg_c+seg_d+seg_e+seg_g,       		// char "d"
	seg_a+seg_d+seg_e+seg_f+seg_g,       		// char "E"
	seg_a+seg_e+seg_f+seg_g						// char "F"
};

/*----------------------------------------------------------------------------*/
/* Function prototype declaration                                             */
/*----------------------------------------------------------------------------*/

//------MISC Function declaration---------------
void User_Sample_Init(void);
void Delay(unsigned int num);

void PowerOn_Init_Go(void);


void Beep_Tone_Start(void);
void Beep_Tone_Stop(void);
void Beep_Tone_Process(void);

//------ADC Function declaration----------------
void InitalADC(void);
//------GPIO Function declaration---------------
void Key_Scan_Process(void);
void Key_In_Process(void);
void GPIO_Init(void);

//------TIMER Function declaration--------------
void TIMER_Init(void);
//------LCD Function declaration----------------
void LCD_Init(void);
void LCD_DATA_DISPLAY(unsigned int LcdBuffer);
void RAM2LCD(unsigned char *Buffer_Adr );
void ClearLCDframe(void);
void ALLLCDframe(void);
void DisplayHYcon(void);
void LCD_DATA_DISPLAY1(unsigned int LcdBuffer);
void LCD_DATA_DISPLAY2(void);

void AD_average(void);				//ADƵ{
void AD_symbol_voltage(void);		//qtϥ
void AD_symbol_curreunt(void);		//qytϥ
void Voltage_measurement(void);		//qqƵ{
void Current_measurement(void);		//qyqƵ{




/*----------------------------------------------------------------------------*/
/* Function Name: User_Sample_Init                                            */
/* Description  : Sample code Initialization Subroutines                      */
/* Arguments    : None.                                                       */
/* Return Value : None.                                                       */
/* Remark       :                                                             */
/*----------------------------------------------------------------------------*/
void User_Sample_Init(void)
{
	SYS_DisableGIE();                           //Disable Global Interrupt.

//------Sys. clock setting----------------------
	DrvCLOCK_SelectIHOSC( TRIM_HAO4MHZ );       //Select HAO= 4MHz.
	DrvCLOCK_EnableHighOSC(E_INTERNAL, 60);     //Enable HAO.
	DrvCLOCK_SelectMCUClock(0, 0);              //Select MCUCKS= HS_CK/1.

//------MISC. system initial--------------------
	GPIO_Init();
	LCD_Init();
	TIMER_Init();
	UserFlag0._byte = 0;
//------Power on initial going------------------
//Beep tone on & LCD display HYcon SCALE about 1Sec.
	ALLLCDframe();
	Delay(0x40000);
	DisplayHYcon();
	Delay(0x40000);
	UserFlag0.b_InitGo_Flag = TRUE;
	SYS_EnableGIE( 4, 0x06 );                   //Enable HW1 & HW2 Int. only.
}

/*----------------------------------------------------------------------------*/
/* Function Name: PowerOn_Init_Go                                             */
/* Description  : Initial all user tasks (likes LCD, ADC for scale etc),      */
/* Arguments    : None.                                                       */
/* Return Value : None.                                                       */
/* Remark       :                                                             */
/*----------------------------------------------------------------------------*/
void PowerOn_Init_Go(void)
{
	unsigned int i;
	InitalADC();
//enable Comb Filter.
	DrvADC_CombFilter( 0 );                 //reset !
	DrvADC_CombFilter( 1 );                 //enable !

	for(i=0; i<16; i++)
	{
		value_buf[i] = 0;
	}
	ADtemp200=0;
	ADtemp1100=0;
	ADtemp110n=1405;
	ADtemp110p=1405;
	ADtemp20n=7;
	ADtemp20p=7;
	nu=0;
	key_Mode=1;
	ch=0;
	ADC_busy=0;
	UserFlag1._byte = 0;
	UserFlag0.b_InitGo_Flag = FALSE;
}

/******************************************************************************/
/* File Name    : user_TIMER.c                                                */
/* Description  : This file implements the customer's TIMER unction.          */
/* Created Date : 2016/05/28                                                  */
/* Created by   :                                                             */
/******************************************************************************/

/*----------------------------------------------------------------------------*/
/* Function Name: TIMER_Init                                                  */
/* Description  : TIMER Initialization Subroutines.                           */
/* Arguments    : None.                                                       */
/* Return Value : None.                                                       */
/* Remark       :                                                             */
/*----------------------------------------------------------------------------*/
void TIMER_Init(void)
{

//------Initial TIMER A for Time Base-----------
//  DrvTMA_Open( 8,0 );                         //Set TimerA int period= HS_CK/32/512= 4MHz/16384= 4mS.
	DrvTMA_Open( 9,0 );                         //Set TimerA int period= HS_CK/32/1024= 4MHz/32768= 8mS.
	DrvTIMER_ClearIntFlag( E_TMA );             //Clear Timer A interrupt flag
	DrvTIMER_EnableInt( E_TMA );                //Timer A interrupt enable

//------Initial TIMER B for PWM-----------------
	DrvTMBC_Clk_Source( E_HS_CK, 0 );           //set TMB Clock from HS_CK/1.
	DrvTMB_Open( E_TMB_MODE0, E_TMB_NORMAL, PWM_4KHZ_TIME );        //set TMB working on normal mode & TMB clock int period= PWM_4KHZ_TIME/HS_CK= 250uS.
}


/*----------------------------------------------------------------------------*/
/* Function Name: Delay()                                                     */
/* Description  : Software delay subroutines.                                 */
/* Arguments    : unsigned int num.                                           */
/* Return Value : None.                                                       */
/* Remark       : num= 10,   delay time= 18u S @4MH HAO, 3V.                  */
/*              : num= 100,  delay time= 40u S @4MH HAO, 3V.                  */
/*              : num= 1000, delay time= 260uS @4MH HAO, 3V.                  */
/*                                                                            */
/*----------------------------------------------------------------------------*/
void Delay(unsigned int num)
{
	for( ; num >0; num-- )
		asm( "NOP" );
}

/******************************************************************************/
/* File Name    : user_GPIO.c                                                 */
/* Description  : This file implements the customer's GPIO function.          */
/* Created Date : 2016/05/28                                                  */
/* Created by   :                                                             */
/******************************************************************************/


/******************************************************************************/
/* File Name    : user_ADC.c                                                  */
/* Description  : This file implements the customer's ADC function.           */
/* Created Date : 2016/05/28                                                  */
/* Created by   :                                                             */
/******************************************************************************/

/*----------------------------------------------------------------------------*/
/* Function Name: ADC_Init                                                    */
/* Description  : ADC Initialization Subroutines                              */
/* Arguments    : None.                                                       */
/* Return Value : None.                                                       */
/* Remark       :                                                             */
/*----------------------------------------------------------------------------*/

void InitalADC(void)
{
	//Set ADC input pin
	DrvADC_SetADCInputChannel(ADC_Input_AIO1,ADC_Input_AIO0);//ADC Input
	//DrvADC_SetADCInputChannel(ADC_Input_AIO0,ADC_Input_AIO1);
	DrvADC_InputSwitch(OPEN);
	DrvADC_RefInputShort(OPEN);
	DrvADC_Gain(0,0);          //Set the ADC Gain
	DrvADC_DCoffset(0);        //DC offset input voltage selection
	//DrvADC_DCoffset(1);        //DC offset input voltage selection
	DrvADC_RefVoltage(VDDA,0); //Set the ADC reference voltage.
	//DrvADC_RefVoltage(VDDA,3);	//VDDA-REFO_I
	//DrvADC_FullRefRange(0);
	DrvADC_FullRefRange(1);    //Set the ADC reference range select.
	//0:Full reference range input
	//1:1/2 reference range input
	//DrvADC_OSR(0);             //0:OSR=32768
	DrvADC_OSR(1);             //1:OSR=16384
	//DrvADC_OSR(2);
	//DrvADC_CombFilter(1);
	//DrvADC_ClkEnable(0,1);     //Setting ADC CLOCK ADCK=HS_CK/6
	DrvADC_ClkEnable(1,1);	 //set ADC CLOCK ADCK = HS_CK/12 = 4MHz/12 = 333KHz  & rising edge is high.
	DrvPMU_VDDA_Voltage(E_VDDA2_4);
	DrvPMU_VDDA_LDO_Ctrl(E_LDO);
	DrvPMU_BandgapEnable();
	DrvPMU_REFO_Enable();
	DrvPMU_AnalogGround(Enable);//ADC analog ground source selection.
	//1:Enable buffer and use internal source
	DrvPMU_LDO_LowPower(0);     //VDD LDO with low power control.
	//0 : Normal;1 : Low power
	Delay(0x1000);
	//Set ADC interrupt
	DrvADC_EnableInt();
	DrvADC_ClearIntFlag();
	DrvADC_Enable();
}

/******************************************************************************/
/* File Name    : user_TIMER.c                                                */
/* Description  : This file implements the customer's TIMER unction.          */
/* Created Date : 2016/05/28                                                  */
/* Created by   :                                                             */
/******************************************************************************/


/******************************************************************************/
/* File Name    : user_LCD.c                                                  */
/* Description  : This file implements the customer's LCD function.           */
/* Created Date : 2016/05/28                                                  */
/* Created by   :                                                             */
/******************************************************************************/

/*----------------------------------------------------------------------------*/
/* Function Name: LCD_Init                                                    */
/* Description  : LCD Initialization Subroutines                              */
/* Arguments    : None.                                                       */
/* Return Value : None.                                                       */
/* Remark       : 1. LCD working@ 4COM x 36SEG, VLCD= from charge pump 2.93V. */
/*              : 2. Charge pump's clock from HS_CK/16= 4M/16= 250KHz).       */
/*              : 3. LCD CLK(LCK) from (HS_CK/64)/9/16= 4M/9216= 434Hz.       */
/*              :    so LCD frame Freq. = 434Hz/(4x2)= 54Hz.                  */
/*----------------------------------------------------------------------------*/
void LCD_Init(void)
{

	clk_10 = 0x40404B4B;                        //Set LCK= (HS_CK/64)/9/16= (HAO/64)/9/16= (4MHz/64)/144= 434Hz & charge pump clock = HS_CK/16.
	DrvLCD_VLCDMode( E_VLCD27 );
	DrvLCD_VLCDTrim( 3 );                       //Trim VLCD as 2.93V.
	DrvLCD_LcdDuty ( E_LCD_DUTY4 );             //enable LCD@1/4 duty.

	DrvLCD_IOMode( 5, 0xFF );                   //Set SEG1/0 as LCD mode.
	DrvLCD_IOMode( 0, 0xFF );                   //Set PT6(SEG2 ~SEG9 ) as LCD mode.
//    DrvLCD_IOMode( 1, 0x07 );                   //Set PT7(SEG10~SEG12) as LCD mode.
	DrvLCD_IOMode( 1, 0x7F );                   //Set PT7(SEG10~SEG16) as LCD mode.
//    DrvLCD_IOMode( 2, 0xFF );                   //Set PT8(SEG18~SEG25) as LCD mode.
//    DrvLCD_IOMode( 3, 0xFF );                   //Set PT9(SEG26~SEG33) as LCD mode.
//    DrvLCD_IOMode( 4, 0xFF );                   //Set PT10(SEG34~SEG35) as LCD mode.
	ClearLCDframe();
	DrvLCD_LCDBuffer( ENABLE );                 //enable LCD working.
	DrvLCD_DisplayMode( E_LCD_NORMAL );         //LCD at normal mode.
}

/*--------------------------------------------------------------------------*/
/* Clear LCD RAM Data                                                       */
/*--------------------------------------------------------------------------*/
void ClearLCDframe(void)
{
	int i=0;
	for(i=0; i<18; i++)
	{
		DisplayBuffer[i]=0x00;
	}
	RAM2LCD( DisplayBuffer );
}


/*--------------------------------------------------------------------------*/
/* SET LCD RAM Data                                                       */
/*--------------------------------------------------------------------------*/
void ALLLCDframe(void)
{
	int i=0;
	for(i=0; i<18; i++)
	{
		DisplayBuffer[i]=0xFF;
	}
	RAM2LCD( DisplayBuffer );
}


/*----------------------------------------------------------------------------*/
/* Display HYcon Char                                                         */
/*----------------------------------------------------------------------------*/
void DisplayHYcon(void)
{
	DisplayBuffer[0]=0x00;
	DisplayBuffer[1]=Char_H;
	DisplayBuffer[2]=Char_Y;
	DisplayBuffer[3]=Char_c;
	DisplayBuffer[4]=Char_o;
	DisplayBuffer[5]=Char_n;
	DisplayBuffer[6]=0x00;
	DisplayBuffer[7]=0x00;
	DisplayBuffer[8]=0x00;
	RAM2LCD( DisplayBuffer );
}

/*----------------------------------------------------------------------------*/
/* Function Name: RAM2LCD                                                     */
/* Description  : RAM buffer data transfer to LCD RAM                         */
/* Arguments    : unsigned char *Buffer_Adr => buffer pointer address.        */
/* Return Value : None.                                                       */
/* Remark       :                                                             */
/*----------------------------------------------------------------------------*/
void RAM2LCD( unsigned char *Buffer_Adr )
{
	unsigned char buf_idx;

	for(buf_idx=0; buf_idx<SEG_BUF_SIZE; buf_idx++)
	{
		DrvLCD_WriteData ( buf_idx, *Buffer_Adr );
		Buffer_Adr++;
	}
}


void Key_Scan_Process(void)
{
	unsigned char key_code, temp;
	unsigned int  r_bit;
	key_code = NULL_KEY_NO;
	temp = NULL_KEY_NO;

	if ( !(r_bit=DrvGPIO_GetBit(E_PT1,2)))			// Check S2 (MODE)
	{
		key_code = 0x00;
	}
	if ( !(r_bit=DrvGPIO_GetBit(E_PT1,1)))			// Check S3  (SET)
	{
		key_code = 0x01;
	}


//------Key in debounce-------------------------
	Key_DB_Cnt++;
	if ( key_code != Key_Code_Buf )
	{
		Key_Code_Buf = key_code;
		Key_DB_Cnt = 0;
	}
	else
	{
		if (Key_DB_Cnt >= KEY_DB_TIME)
		{
			Key_DB_Cnt = 0;
			if ( Key_Code_Buf == NULL_KEY_NO )
			{
				UserFlag0.b_KeyOn_Flag = FALSE;
			}
			else
			{
				if (UserFlag0.b_KeyOn_Flag == FALSE)
				{
					UserFlag0.b_KeyOn_Flag = TRUE;
					UserFlag0.b_KInPro_Flag = TRUE;
					Key_Code_No = Key_Code_Buf;
				}
				Sleep_Time_Cnt = SLEEP_TIME;
			}
		}
	}
	DrvGPIO_PT1_DisableOUTPUT( 0xFF );                          //close PT1[7:0] OE.
}



/******************************************************************************/
/* File Name    : user_GPIO.c                                                 */
/* Description  : This file implements the customer's GPIO function.          */
/* Created Date : 2016/05/28                                                  */
/* Created by   :                                                             */
/******************************************************************************/

/*----------------------------------------------------------------------------*/
/* Function Name: GPIO_Init                                                   */
/* Description  : GPIO Initialization Subroutines                             */
/* Arguments    : None.                                                       */
/* Return Value : None.                                                       */
/* Remark       :                                                             */
/*----------------------------------------------------------------------------*/
void GPIO_Init(void)
{
	DrvGPIO_ClkGenerator( E_HS_CK, 3 );                         //Set IO sampling clock input source is HS_CK, and IOCLK is HS_CK/4.
//  DrvGPIO_ClkGenerator( E_HS_CK, 11);                         //Set IO sampling clock input source is HS_CK, and IOCLK is HS_CK/1024.
	DrvGPIO_PT1_IntTriggerPorts( 0x0F, E_N_Edge );              //PT1[3:0] interrupt trigger method is negative edge.
	DrvGPIO_PT1_DisableINT( 0xFF );                             //PT1[7:0] interrupt disable.
	DrvGPIO_PT1_ClearIntFlag( 0xFF );                           //clear PT1[7:0] interrupt flag.
	DrvGPIO_PT1_EnablePullHigh( 0x06 );                         //enable PT1[3:0] pull high 75K ohm.(set PT1.1 PT1.2)
	DrvGPIO_PT1_EnableINPUT( 0x06 );                            //set PT1[3:0] as input port. (set PT1.1 PT1.2)
	DrvGPIO_PT1_DisableOUTPUT( 0xFF );                          //close Output PT1[7:0] OE.

//------PWM function initial--------------------
	DrvGPIO_Open( E_PT2, 0x03, E_IO_OUTPUT );                   //set PT2[1:0] as output port.
	DrvPWM_CountCondition( PWM_4KHZ_TIME/2, PWM_4KHZ_TIME/2 );  //Set TBC1 as 50% duty, TBC2 as 50% duty.
	DrvGPIO_ClrPortBits( E_PT2, 0x03 );                         //set PT2[1:0] as output low.
}



/*----------------------------------------------------------------------------*/
/* Function Name: Beep_Tone_Start                                             */
/* Description  : Start PWM beep tone.                                        */
/* Arguments    : None.                                                       */
/* Return Value : None.                                                       */
/* Remark       :                                                             */
/*----------------------------------------------------------------------------*/
void Beep_Tone_Start(void)
{
	Beep_Tone_Cnt = BEEP_TONE_TIME;
	DrvTMB_Open( E_TMB_MODE0, E_TMB_NORMAL, PWM_4KHZ_TIME );        //set TMB working on normal mode & TMB clock int period= PWM_4KHZ_TIME/HS_CK= 250uS.
	DrvPWM0_Open( 0, 1, 2 );                                        //Set PT2.0= PWMO0, PT2.1= PWMO1 and PWMO0 working on PWMA mdoe with normal pulse output.
	DrvPWM1_Open( 0, 0, 2 );                                        //Set PT2.0= PWMO0, PT2.1= PWMO1 and PWMO1 working on PWMA mdoe with reverse pulse output.
}

/*----------------------------------------------------------------------------*/
/* Function Name: Beep_Tone_Stop                                              */
/* Description  : Stop PWM beep tone.                                         */
/* Arguments    : None.                                                       */
/* Return Value : None.                                                       */
/* Remark       :                                                             */
/*----------------------------------------------------------------------------*/
void Beep_Tone_Stop(void)
{
	Beep_Tone_Cnt = 0;
	DrvTMB_Close();
	DrvPWM0_Close();
	DrvPWM1_Close();
	DrvGPIO_ClrPortBits( E_PT2, 0x03 );         //set PT2[1:0] as output low.
}


/*----------------------------------------------------------------------------*/
/* Function Name: Beep_Tone_Process                                           */
/* Description  : Beep tone time processing.                                  */
/* Arguments    : None.                                                       */
/* Return Value : None.                                                       */
/* Remark       :                                                             */
/*----------------------------------------------------------------------------*/
void Beep_Tone_Process(void)
{
	if (Beep_Tone_Cnt != 0)
	{
		Beep_Tone_Cnt--;
		if (Beep_Tone_Cnt <= 0)
			Beep_Tone_Stop();
	}
}


/*----------------------------------------------------------------------------*/
/* Function Name: Key_In_Process                                              */
/* Description  : Key in tasks processing.                                    */
/* Arguments    : None.                                                       */
/* Return Value : None.                                                       */
/* Remark       :                                                             */
/*----------------------------------------------------------------------------*/
void Key_In_Process(void)
{
	unsigned int i;
//------Rest for newly No. key in---------------
	NoKey_Reset_Cnt++;
	if ( NoKey_Reset_Cnt > NO_KEY_RESET_TIME )
	{
		UserFlag1.b_DotKey_Flag = FALSE;
		NoKey_Reset_Cnt = 0;
		NoBuf_Idx = 2;
		NoKeyBuf[0] = 0;
		NoKeyBuf[1] = 0;
		NoKeyBuf[2] = 0;
		NoKeyBuf[3] = 0;
	}
	if( UserFlag0.b_KInPro_Flag != TRUE )
		return;
	UserFlag0.b_KInPro_Flag = FALSE;

	switch( Key_Code_No )
	{
	case 0:					//Mode select key
		ADC_busy=0;
		key_Mode++;
		if(key_Mode>=3)	key_Mode=1;		//Mode 1: voltage check
		asm("nop");						//Mode 2: current check
		nu=0;
		break;

	case 1:					//Set key
	{
		switch(key_Mode)
		{
		case 0x00:
			break;
		case 0x01:
			DrvADC_Disable();
			DrvADC_SetADCInputChannel(ADC_Input_AIO1,ADC_Input_AIO0);//ADC Input
			DrvADC_Enable();
			DrvADC_CombFilter( 0 );                 //reset !
			DrvADC_CombFilter( 1 );                 //enable !
			for(i=0; i<16; i++)
			{
				value_buf[i] = 0;
			}
			Delay(0x1000);
			Voltage_measurement();
			ADC_busy=1;
			break;//*20V		//Is20VqqƵ{

		case 0x02:
			DrvADC_Disable();
			DrvADC_SetADCInputChannel(ADC_Input_AIO2,ADC_Input_AIO1);//ADC Input
			DrvADC_Enable();
			DrvADC_CombFilter( 0 );                 //reset !
			DrvADC_CombFilter( 1 );                 //enable !
			for(i=0; i<16; i++)
			{
				value_buf[i] = 0;
			}
			Delay(0x1000);
			Current_measurement();
			ADC_busy=1;
			break;//*110mA		//Is110mAqyqƵ{

		default:
			break;
		}
	}
	default:
		asm("nop");
		break;
	}
	Beep_Tone_Start();
}

void Voltage_measurement(void)				//20VqqƵ{
{
	AD_symbol_voltage();						//IstqPwƵ{
	if(nu==0)					//JA
	{
		AD_average();					//IsADƵ{
		if(sum<131072)
		{
			ADtemp101=100*(sum-ADtemp200)/(ADtemp20n-ADtemp200);
			ADtemp100=ADtemp101%100;
			if(ADtemp100>70) ADtemp101+=100;
			ADtemp101=ADtemp101/100;
			ADtemp101=ADtemp101*10;
			ADtemp101=ADtemp101>>3;
			ADtemp101=ADtemp101/10;
			ADtemp101=ADtemp101*10;
			if(ADtemp101<9)
			{
				ADtemp101=0;
				nu=0;
			}
			LCD_DATA_DISPLAY(ADtemp101);					//q
		}
		else
		{
			if(sum<131172)
			{
				ADtemp101=100*(sum-ADtemp200)/(ADtemp20n-ADtemp200);
				ADtemp101*=10;
				ADtemp101=ADtemp101>>3;
				ADtemp101=ADtemp101/10;
				ADtemp101=ADtemp101*10;
			}
			else
			{
				nu=0;
				ADtemp101=0;
			}
			LCD_DATA_DISPLAY(ADtemp101);
		}
	}
	if(nu==1)												//Xtq
	{
		AD_average();												//IsADƵ{
		if(sum<56080)
		{
			ADtemp101=100*(sum+ADtemp200)/(ADtemp20n+ADtemp200);
			ADtemp100=ADtemp101%10;
			if(ADtemp100>70) ADtemp101+=100;
			ADtemp101=ADtemp101/100;
			ADtemp101=ADtemp101*10;
			ADtemp101=ADtemp101>>3;
			ADtemp101=ADtemp101/10;
			ADtemp101=ADtemp101*10;
			if(ADtemp101<10)
			{
				ADtemp101=0;
				nu=0;
			}
			LCD_DATA_DISPLAY(ADtemp101);					//q
		}
		else
		{
			if(sum<114050)
			{
				ADtemp101=(sum+ADtemp200)/(ADtemp20n+ADtemp200);
				ADtemp101*=10;
				ADtemp101=ADtemp101>>3;
				ADtemp101=ADtemp101/10;
				ADtemp101=ADtemp101*10;
			}
			else
			{
				nu=0;
				ADtemp101=0;
			}
			LCD_DATA_DISPLAY(ADtemp101);
		}
	}
}


/*----------------------------------------------------------------------------*/
void Current_measurement(void)										//110mAqyqƵ{
{
	AD_symbol_curreunt();
	if(nu==0)											//JA
	{
		AD_average();
		ADtemp101=100*(sum+1)/(ADtemp110n-ADtemp1100);	//ƭȹB
		ADtemp101=ADtemp101>>3;
		LCD_DATA_DISPLAY1(ADtemp101);					//current display
	}
	if(nu==1)
	{
		AD_average();
		ADtemp101=100*(sum+1)/(ADtemp110n-ADtemp1100);
		ADtemp101=ADtemp101>>3;
		if(ADtemp101==0)
		{
			nu=0;
		}
		LCD_DATA_DISPLAY1(ADtemp101);
	}
}


void AD_average(void)									//ADCƵ{
{
	unsigned char t;
	while(ok)									//ADC_OK=1
	{
		ok=0;
		ADtemp10=(ADCData>>14);
		//ADtemp10=(ADCData>>17);
		value_buf[11]=value_buf[10];
		value_buf[10]=value_buf[9];
		value_buf[9]=value_buf[8];
		value_buf[8]=value_buf[7];				//ưoiBz
		value_buf[7]=value_buf[6];
		value_buf[6]=value_buf[5];
		value_buf[5]=value_buf[4];
		value_buf[4]=value_buf[3];
		value_buf[3]=value_buf[2];
		value_buf[2]=value_buf[1];
		value_buf[1]=ADtemp10;
		sum=0;
		for(t=8; t>0; t--)
		{
			sum+=value_buf[t];
		}
		average=((sum)>>3);
	}
	if(average<0)
	{
		average*=-1;
	}
	sum=average;
}


void AD_symbol_voltage(void)														//qtPwƵ{
{
	int t;
	sum=0;
	for(t=0; t<8; t++)												//NADJ8
	{
		ADtemp10=(ADCData>>17);
		sum+=ADtemp10;
	}
	if(sum>=-30)													//{pJPw
	{
		if(ch==0)													//e@Pw
		{
			nu=0;													//ثeJ
			ch=0;
			DrvADC_SetADCInputChannel(ADC_Input_AIO0,ADC_Input_AIO1);//AIO0BAIO1`tm
			goto by;												 //}{
		}
		if(ch==1)													 //e@Pwt
		{
			nu=1;													 //ثeJt
			ch=1;
			DrvADC_SetADCInputChannel(ADC_Input_AIO1,ADC_Input_AIO0);//AIO0BAIO1A˶O
			goto by;
		}
	}
	if(sum<0)														//{pJPw
	{
		if(ch==0)													//e@J
		{
			nu=1;													//{pPwt
			ch=1;
			DrvADC_SetADCInputChannel(ADC_Input_AIO1,ADC_Input_AIO0);//AIO0BAIO1A˰tm
			goto by;
		}
		if(ch==1)													//e@`t
		{
			nu=0;													//{pPw
			ch=0;
			DrvADC_SetADCInputChannel(ADC_Input_AIO0,ADC_Input_AIO1);//AIO0BAIO1`tm
			goto by;
		}
	}
by:
	asm("NOP");
	Delay(0x1000);
}


void AD_symbol_curreunt(void)														//qytPwƵ{
{
	int t;
	sum=0;
	for(t=0; t<8; t++)												//NADJ8
	{
		ADtemp10=(ADCData>>17);
		sum+=ADtemp10;
	}
	if(sum>=-30)													//{pJPw
	{
		if(ch==0)													//e@Pw
		{
			nu=0;													//ثeJ
			ch=0;
			DrvADC_SetADCInputChannel(ADC_Input_AIO2,ADC_Input_AIO1);//AIO0BAIO1`tm
			goto by1;												 //}{
		}
		if(ch==1)													 //e@Pwt
		{
			nu=1;													 //ثeJt
			ch=1;
			DrvADC_SetADCInputChannel(ADC_Input_AIO1,ADC_Input_AIO2);//AIO0BAIO1A˶O
			goto by1;
		}
	}
	if(sum<0)														//{pJPw
	{
		if(ch==0)													//e@J
		{
			nu=1;													//{pPwt
			ch=1;
			DrvADC_SetADCInputChannel(ADC_Input_AIO1,ADC_Input_AIO2);//AIO0BAIO1A˰tm
			goto by1;
		}
		if(ch==1)													//e@`t
		{
			nu=0;													//{pPw
			ch=0;
			DrvADC_SetADCInputChannel(ADC_Input_AIO2,ADC_Input_AIO1);//AIO0BAIO1`tm
			goto by1;
		}
	}
by1:
	asm("NOP");
	Delay(0x1000);
}



void LCD_DATA_DISPLAY(unsigned int LcdBuffer)		//ܿ
{
	DisplayBuffer[0]=0x00;
	DisplayBuffer[1]=0x00;
	DisplayBuffer[2]=0x00;
	DisplayBuffer[3]=0x00;
	DisplayBuffer[4]=0x00;
	DisplayBuffer[5]=0x00;
	int i;
	for(i=5; i>=0; i--)
	{
		DisplayBuffer[i]=seg[LcdBuffer%10];
		LcdBuffer=LcdBuffer/10;
	}

	if(nu==1) DisplayBuffer[6]=S_Minus;				//t
	else DisplayBuffer[6]=0x00;
	DisplayBuffer[7]=S_V;							//qV
	DisplayBuffer[2]=DisplayBuffer[2]|seg_h;		//pI
	DisplayBuffer[8]=S21;
	RAM2LCD( DisplayBuffer );
}
void LCD_DATA_DISPLAY1(unsigned int LcdBuffer)
{

	DisplayBuffer[0]=0x00;
	DisplayBuffer[1]=0x00;
	DisplayBuffer[2]=0x00;
	DisplayBuffer[3]=0x00;
	DisplayBuffer[4]=0x00;
	DisplayBuffer[5]=0x00;
	int i;
	for(i=5; i>=0; i--)
	{
		DisplayBuffer[i]=seg[LcdBuffer%10];
		LcdBuffer=LcdBuffer/10;
	}
	if(nu==1) DisplayBuffer[6]=S_Minus;				//t
	else DisplayBuffer[6]=0x00;
	DisplayBuffer[7]=S_A;							//qyA
	DisplayBuffer[6]=DisplayBuffer[6]|S_m1;			//m
	DisplayBuffer[4]=DisplayBuffer[4]|seg_h;		//pI
	DisplayBuffer[8]=S19;
	RAM2LCD( DisplayBuffer );
}

void LCD_DATA_DISPLAY2(void)
{
	if(key_Mode==1 && ADC_busy==0)
	{
		DisplayBuffer[0]=0x00;
		DisplayBuffer[1]=0x00;
		DisplayBuffer[2]=0x00;
		DisplayBuffer[3]=0x00;
		DisplayBuffer[4]=seg[2];				//20V
		DisplayBuffer[5]=seg[0];
		//DisplayBuffer[6]=DisplayBuffer[6]&0xF7;
		DisplayBuffer[6]=DisplayBuffer[6]&0xF6;
		DisplayBuffer[7]=S_V;
		DisplayBuffer[8]=S21;
//		RAM2LCD( DisplayBuffer );
	}
	if(key_Mode==2 && ADC_busy==0)
	{
		DisplayBuffer[0]=0x00;
		DisplayBuffer[1]=0x00;
		DisplayBuffer[2]=0x00;
		DisplayBuffer[3]=seg[1];				//110mA
		DisplayBuffer[4]=seg[1];
		DisplayBuffer[5]=seg[0];
		DisplayBuffer[6]=S_m1;
		DisplayBuffer[7]=S_A;
		DisplayBuffer[8]=S19;
//		RAM2LCD( DisplayBuffer );
	}
	if(ADC_busy==1)  							//ثeqιqy
	{
		switch(key_Mode)
		{
//			  case 0x00:break;
		case 0x01:
			Voltage_measurement();
			break;//*20V		//Is20VqqƵ{

		case 0x02:
			Current_measurement();
			break;//*110mA		//Is110mAqyqƵ{

		default:
			break;
		}
	}
	RAM2LCD( DisplayBuffer );
}

/*----------------------------------------------------------------------------*/
/* End Of File                                                                */
/*----------------------------------------------------------------------------*/
